SystemOrganization addCategory: #'TP2-Parte3'!

Object subclass: #AplicarUnaFuncion
	instanceVariableNames: 'condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!AplicarUnaFuncion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
CrearEstrategiaCon: unaCondicion
	
	|nuevaEstrategia|
	
	nuevaEstrategia := EjecutarTodasEnOrden new.
	nuevaEstrategia condicion: unaCondicion.
	^nuevaEstrategia.! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
condicion
	^condicion.! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
condicion: unaCondicion 
	condicion := unaCondicion.! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	self resolverConflictoPara: unMetodo entre: unTrait y: unaClase bajo: condicion.

	"| codigoOriginal conflictivos withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: 'original',codigoOriginal.
	
		unaClase compile:
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			| conflictivos retorno argumentos withsArmados|
	
			argumentos := (EjecutarTodasEnOrden new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
			conflictivos := ( (EjecutarTodasEnOrden new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := conflictivos inject: retorno into: [ :resultado :implementador | (self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
				     																	    self perform: #auxiliar with: resultado ].
			(self class) methodDict at: #auxiliar put: nil.
		
			^retorno.
			'
	]."! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #EjecutarTodasEnOrden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EjecutarTodasEnOrden class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:55'!
CrearEstrategia
	|nuevaEstrategia|
	
	nuevaEstrategia := EjecutarTodasEnOrden new.
	^nuevaEstrategia.! !

!EjecutarTodasEnOrden class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 20:50'!
CrearEstrategiaCon: unaCondicion
	
	|nuevaEstrategia|
	
	nuevaEstrategia := EjecutarTodasEnOrden new.
	nuevaEstrategia condicion: unaCondicion.
	^nuevaEstrategia.! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 14:43'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 16:53'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 20:51'!
condicion
	^condicion.! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 20:51'!
condicion: unaCondicion 
	condicion := unaCondicion.! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:47'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal conflictivos withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: 'original',codigoOriginal.
	
		unaClase compile:
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			| conflictivos retorno argumentos withsArmados|
	
			argumentos := (EjecutarTodasEnOrden new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
			conflictivos := ( (EjecutarTodasEnOrden new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := conflictivos inject: retorno into: [ :resultado :implementador | (self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
				     																	    self perform: #auxiliar with: resultado ].
			(self class) methodDict at: #auxiliar put: nil.
		
			^retorno.
			'
	].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:11'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #ExaminarCondicion
	instanceVariableNames: 'condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!ExaminarCondicion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:51'!
CrearEstrategiaCon: unaCondicion
	
	|nuevaEstrategia|
	
	nuevaEstrategia := ExaminarCondicion new.
	nuevaEstrategia condicion: unaCondicion.
	^nuevaEstrategia.! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
condicion
	^condicion.! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
condicion: unaCondicion 
	condicion := unaCondicion.! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:40'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal conflictivos withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: 'original',codigoOriginal.
	
		unaClase compile:
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			| conflictivos retorno argumentos withsArmados|
	
			argumentos := (ExaminarCondicion new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
			conflictivos := ( (ExaminarCondicion new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := conflictivos inject: retorno into: [ :resultado :implementador |
				(resultado ',self condicion,' ) ifFalse: [^resultado].
				(self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
				self perform: #auxiliar with: resultado 
			].
			(self class) methodDict at: #auxiliar put: nil.
		
			^retorno.
			'
	].! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #Refactor3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 17:49'!
agregarTrait: unTrait a: unaClase con: unaEstrategia
	
	|metodosConflictivos|
	
	( unaClase traits includes: unTrait ) ifFalse: 
	[
		unaClase addToComposition: unTrait.
	
		metodosConflictivos := unTrait selectors select: [ :selector | self esConflitivo: selector en: unaClase ].
	
		metodosConflictivos do: [ :selector | unaEstrategia resolverConflictoPara: selector entre: unTrait  y: unaClase ].
	]! !

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/2/2013 00:19'!
esConflitivo: unSelector en: unaClase
	|traits|
	
	traits := unaClase traits.
	
	^ (unaClase selectors includes: unSelector) | ( traits notEmpty and: [ traits anySatisfy: [ :unTrait | self esConflitivo: unSelector en: unTrait ] ] ). 
	
	"Mejorar TODO"! !
